//
//   ODT_Loader.h
//

#ifndef ODT_LoaderDef
#define ODT_LoaderDef 1

#include <windows.h>
#include <stdio.h>
#include <vector>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\status_bar.h"
#include "..\UtilsLib\controls.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\abstract_model.h"

#include "config.h"


#define  ODT_Loader_CLASS_NAME    "ODT_Loader"
#define  ODT_Loader_OBJECT_TYPE   "ODT_Loader"


class ODT_Loader : protected ToolClass, protected TicksUserClass, protected FastTicksUserClass {
public:
	static const char* const CLASS_NAME; // "ODT_Loader"
	
	static const char* const OBJECT_TYPE; // "ODT_Loader"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~ODT_Loader(){}

	StringParameter  sC_Prompt;
	IntegerConstant  nC_SecondsToWaitAtPrompt;
	StringParameter  sP_ScriptFile;
	StateVarType     St_Load;

	Input_SocketClass    ByteInputSocket;
	Output_SocketClass   ByteOutputSocket;
	
	void ByteReceiver( PVOID pData, SocketClass *pSender );
	int  nPhase;
	
	void Tick();
	void FastTick();

	void Initializer();
	void Load_StateCallback( const char*, int );
	void Load();
	bool LoadCheck();
	bool bLoading;
	bool bClearLoadState;
	
	dword  uLastByteInput_TC;

	byte  acBuf[1024*512];
	byte *pChar;
	void  SendByte();
	byte  NextByteToSend();
	int   nScriptSize; 
	
	bool  bWaitForAnswer;
	bool  bWaitForPrompt;
	bool  bWaitForEcho;
	byte  cSentByte;

private:
	ODT_Loader( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};


#endif
