//
//   UKNCcomSender.h
//

#ifndef UKNCcomSenderDef
#define UKNCcomSenderDef 1

#include <windows.h>
#include <stdio.h>
#include <vector>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\status_bar.h"
#include "..\UtilsLib\controls.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\abstract_model.h"

#include "config.h"


#define  UKNCcomSender_CLASS_NAME    "UKNCcomSender"
#define  UKNCcomSender_OBJECT_TYPE   UKNCcomSender_CLASS_NAME


class UKNCcomSender : protected ToolClass, protected TicksUserClass {
public:
	static const char* const CLASS_NAME; // "UKNCcomSender"
	
	static const char* const OBJECT_TYPE; // "UKNCcomSender"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~UKNCcomSender(){}

	StringConstant   sC_Prompt;
	StringParameter  sP_BootFile;
	IntegerParameter nP_BytesToSend;
	IntegerConstant  nC_ImprintDate;
	IntegerConstant  nC_SecondsToWaitAtPrompt;
	StateVarType     St_Load;

	Input_SocketClass    ByteInputSocket;
	Output_SocketClass   ByteOutputSocket;
	
	void ByteReceiver( PVOID pData, SocketClass *pSender );
	int  nPhase;

	dword  uLastByteInput_TC;
	
	void Tick();

	void Initializer();
	void Load_StateCallback( const char*, int );
	void Load();
	bool LoadCheck();
	bool bLoading;
	bool bClearLoadState;
	
	byte  acBuf[1024*128];
	int   nBootSize; 

private:
	UKNCcomSender( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};


#endif
