//
//  FrameStream.h
//
#ifndef FrameStreamDefs
#define FrameStreamDefs 1

#include "main_classes.h"

//
//  FrameReceiver( PVOID pData, SocketClass *pSender )
//
//  pData -    BGR_Frame_Class.
//
//
#define  acBGR_FrameStreamType      "BGR_FrameStream"

//
//

class BGR_Frame_Type {
public:
 const	int				  nWidth;
 const	int				  nHeight;
		dword		     *pBGR_Buf;
		dword			  dwFrameNum;
		dword			  dwLastUniqueFrameNum;
		int				  nFirstUniqueScanLine;
		int				  nLastUniqueScanLine;
		HBITMAP           hBitmap;
		BITMAPINFOHEADER  bmih;		
		HDC               hDC;
		LockVarType		  LockVar;
		
		BGR_Frame_Type( int nWIDTH, int nHEIGHT ):
		nWidth(   nWIDTH ),
		nHeight(  nHEIGHT ),
		pBGR_Buf( NULL ),
		dwFrameNum(0),
		dwLastUniqueFrameNum(0),
		nFirstUniqueScanLine(0),
		nLastUniqueScanLine( nHEIGHT-1 )
		{
			memset( &bmih, 0, sizeof(BITMAPINFOHEADER) );
			bmih.biSize    = sizeof(BITMAPINFOHEADER);
			bmih.biWidth   = nWidth;
			bmih.biHeight  = -nHeight;
			bmih.biPlanes  = 1;
			bmih.biBitCount = 32;
			
			hBitmap = CreateDIBSection(NULL, (BITMAPINFO*)&bmih, DIB_RGB_COLORS, (void**)(&pBGR_Buf), NULL, 0);

			hDC = CreateCompatibleDC( NULL );
			SelectObject( hDC, hBitmap );
		}
		
		~BGR_Frame_Type()
		{
			DeleteDC( hDC );
			DeleteObject( hBitmap );
		}
		
//		void CopyTo( HDC hdcWin, int nX0, int nY0 ) { BitBlt( hdcWin, nX0, nY0, nWidth, nHeight, hDC, 0, 0, SRCCOPY ); }
		void CopyTo( HDC hdcWin, int nX0, int nY0 ) { SetDIBitsToDevice( hdcWin, nX0, nY0, nWidth, nHeight, 0, 0, 0, nHeight, pBGR_Buf, (BITMAPINFO*)&bmih, DIB_RGB_COLORS ); }

		void UpdateTo( HDC hdcWin, int nX0, int nY0 ) 
		{
			int nUpdateHeight = nLastUniqueScanLine - nFirstUniqueScanLine + 1;
			SetDIBitsToDevice( hdcWin, nX0, nY0 + nFirstUniqueScanLine, nWidth, nUpdateHeight, 0, 0, 0, nFirstUniqueScanLine + nUpdateHeight, pBGR_Buf, (BITMAPINFO*)&bmih, DIB_RGB_COLORS );
		}
		
		void CopyFrom( HDC hdcWin ) 
		{
			BitBlt( hDC, 0, 0, nWidth, nHeight, hdcWin, 0, 0, SRCCOPY );
			
			dwLastUniqueFrameNum = dwFrameNum;
			nFirstUniqueScanLine = 0;
			nLastUniqueScanLine  = nHeight-1;
		} 
};

#endif
