#ifndef _RESOURCEEX_H
#define _RESOURCEEX_H

// Functions to load resources for a specific language
// If wLanguage is 0xFFFF then the app language is used. Call SetAppLanguage before any resources
// are used. If SetAppLanguage is not called, the default UI language is used.
//
///////////////////////////////////////////////////////////////////////////////

// Loads accelerator resource
HACCEL LoadAcceleratorsEx( HINSTANCE hInstance, LPCTSTR lpTableName, WORD wLanguage=0 );
HACCEL LoadAcceleratorsEx( HINSTANCE hInstance, UINT uTableID, WORD wLanguage=0 );

// Loads a string resource
int LoadStringEx( HINSTANCE hInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax, WORD wLanguage=0 );

// Loads a menu resource
HMENU LoadMenuEx( HINSTANCE hInstance, LPCTSTR lpMenuName, WORD wLanguage=0 );
HMENU LoadMenuEx( HINSTANCE hInstance, UINT uMenuID, WORD wLanguage=0 );

// Dialog box creation
INT_PTR DialogBoxParamEx( HINSTANCE hInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam, WORD wLanguage=0 );
HWND CreateDialogParamEx( HINSTANCE hInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam, WORD wLanguage=0 );
INT_PTR DialogBoxEx( HINSTANCE hInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, WORD wLanguage=0 );
HWND CreateDialogEx( HINSTANCE hInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, WORD wLanguage=0 );

INT_PTR DialogBoxParamEx( HINSTANCE hInstance, UINT uTemplateID, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam, WORD wLanguage=0 );
HWND CreateDialogParamEx( HINSTANCE hInstance, UINT uTemplateID, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam, WORD wLanguage=0 );
INT_PTR DialogBoxEx( HINSTANCE hInstance, UINT uTemplateID, HWND hWndParent, DLGPROC lpDialogFunc, WORD wLanguage=0 );
HWND CreateDialogEx( HINSTANCE hInstance, UINT uTemplateID, HWND hWndParent, DLGPROC lpDialogFunc, WORD wLanguage=0 );

#endif
