//
//  TextStream.h
//
#ifndef TextStreamDefs
#define TextStreamDefs 1

#include "main_classes.h"

//
//  TextReceiver( PVOID pData, SocketClass *pSender )
//
//  pData -   .
//
//

#define  acTextStreamType    "TextStream"

///////////////////////

class TextstreamChannelClass : protected SocketOwnerClass {
public:
	static const char* const CLASS_NAME; // "TextstreamChannel"

	static const char* const OBJECT_TYPE;     // "TextStream"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;

protected:
	virtual ~TextstreamChannelClass(){};

	Input_SocketClass       InputSocket;
	TextOutput_SocketClass  OutputSocket;
    
private:
	TextstreamChannelClass( ConfigInterface *pConfig, const char *acAlias );
	void TextReceiver( PVOID pData, SocketClass *pSender )
	{
		if( !bOutputSocketInUse )
		{
			bOutputSocketInUse = true;
			OutputSocket.Send( pData );
			bOutputSocketInUse = false;
		}
	}

	bool bOutputSocketInUse;

	static unsigned int nObjectsCount;
};




#endif