//
// WFTabs.h
//

#include <windows.h>
#include "workfield_class.h"

//
#pragma warning(disable:4996)

#ifndef WFTabsClassDef
#define WFTabsClassDef 1
class WFTabsClass {
friend LRESULT CALLBACK NewTabProc( HWND hWndTab, UINT uMsg, WPARAM wParam, LPARAM lParam );
public:
	static const char* const CLASS_NAME; // = "WFTabs";

//	static LRESULT CALLBACK NewTabProc( HWND   hWndTab, UINT   uMsg, WPARAM wParam, LPARAM lParam );

	WFTabsClass( HWND hwndParent );
	virtual void Destroy() { delete this; }

	virtual void Activate( bool bActive );

	virtual void AddWFTab( WorkField *pWF, const char *sTabName );
	virtual void DelWFTab( WorkField *pWF );
	virtual void Resize( int dX, int dY );
	virtual WorkField *SelChange();
	virtual HWND Get_hWndTab() { return hWndTab; }
	virtual WorkField  *Get_pActiveWF(){ return pActiveWF; }
	
	virtual void SetActiveWF( WorkField  *pWF );
	
	
	virtual HWND GetFocusHWND()
	{ 
		if( pActiveWF ) { return pActiveWF->GetFocusHWND(); }
		return NULL;
	}
	
	virtual void Parse_WM_MOUSEWHEEL( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
	{
		if( pActiveWF ) { pActiveWF->Parse_WM_MOUSEWHEEL( hWnd, msg, wParam, lParam ); }
	}

	
private:
	virtual ~WFTabsClass();
	HWND WINAPI CreateWFTabControl( HWND hwndParent );
	
	char        acObjectName[128];
    static int  ObjectsCount( bool = false );

//	char str[128];
	Console  *pCon;

	HFONT  fontT;
	HBRUSH hBrushTab;

	struct TabDataType {
	  bool     bActive;
	  WorkField *pWF;
	};

	RECT rc;
	
	int   nTabsID;
	NMHDR NMHeader;

	HWND hWndTab;
	HWND hWndParent;
	WorkField  *pActiveWF;
	
	bool bParentWF_Active;

	TabDataType aTabData[48];
	int         nMaxTab;
	int         nLastActiveTab;
	
	bool  bObjectDestroing;
	bool  bWindowDestroed;
	
};
#endif