//
//  lng.h  -  Header for lng.cpp
//
#ifndef LNG_DEFS
#define LNG_DEFS 1

#include <vector>
#include <string>
#include <map>


typedef std::map<std::string,std::string> mStringsType;

extern mStringsType  mStrings;
#define PM_STRINGS  &mStrings


//
//   .lng :
//  ------------------
//  [languages]
//  English = ENG
//   = RUS
//
//  [strings]
//  DEF:"Module [%s] not found!\n"
//  ENG:"The Module [%s] isn't found!\n"
//  RUS:" [%s]  !\n"
//
//  DEF:"Hello!\n"
//  RUS:"!\n"
//  ------------------
//
//    -   ,     lng, 
//                      'DEF'.    
//                       .
//
//  ,      -       
//  (..   'DEF'), ,  ()   [strings]  lng    
//  'ENG'-,    [languages]   "English = ENG",     
//    'English',         .
//
//     lng      .
//    ( RUS, ENG, 5  .. ) -  .
//    "DEF"   [languages] .
//      lng  ';' -  .
//

/*
struct LanguageRecordType {
	std::string sName;  //  "English"
	std::string sAbbr;  //  "ENG"
};
//*/

typedef std::vector<std::string> LanguagesListType;
//
//   LanguagesListType -   (   std::string ). 
//
//  ,
//  LanguagesListType Languages;
//
//  Languages.size() ==     ();
//  Languages[0] ==  ( : "English" )       std::string
//  Languages[0].c_str() ==  ,      ASCIIZ ( C-string ).
//



extern LanguagesListType LoadLanguagesList( const char *acPath = "" );
// 
//          LanguagesListType.
//
//   acPath    -        .
//   acPath    -      "default.lng"    
//                                 .           
//                                 ".lng"          ,
//                                       .    
//                                       -     .


extern LanguagesListType LoadModuleLanguagesList( const char *acProgName, const char *acPath = "" );
// 
//    ,   '.lng'   .
//      ( c        '.lng' ).
//          '*.lng'
//  ,     'HD_module'     'HD_module.lng',
//   (    ) -  : 'HD_module[JPN].lng', 'HD_module-.lng',
//  'HD_module.XXX.lng'   ,   'HD_module*.lng'
//


extern bool LoadLanguage( const char *acPath, const char *acLanguage, mStringsType *pmStrings );
//
//    ()     .
//
//   acPath    -       .
//   acPath    -      "default.lng".    
//                                   -          
//                                 ".lng"           -
//                                      .
//


extern bool LoadModuleLanguage( const char *acProgName, const char *acPath, const char *acLanguage, mStringsType *pmStrings, bool bReset = true );
//
//    (),    '*acLanguage'  '.lng'   .
//
//      ( c        '.lng' ).
//        -        '*.lng'
//  ,     'HD_module'     'HD_module.lng',
//   (    ) -  : 'HD_module[JPN].lng', 'HD_module..lng',
//  'HD_module2.lng'   ,   'HD_module*.lng'
//



#define LNG(x) (Lng( PM_STRINGS, x))

extern char* Lng( mStringsType* pmStrings, const char* acStr );

#endif
