
#ifndef WorkFieldClassDefs
#define WorkFieldClassDefs 1

#include <stdio.h>

//#include "objects_log.h"
#include "sysmac.h"
#include "window_init_data.h"

#include "main_classes.h"

//
//   WorkField_class.h
//

const dword  WorkField_Generation = 1;
const dword  WorkField_Version    = 1;


class WorkField :public GlobalClass {
public:
	static const char* const CLASS_NAME; // = "WorkField";

	WorkField( DWindowInitData* );
	virtual void Destroy() { delete this; }

	virtual void Show( int );
	virtual void Activate( bool ){}
	virtual HWND GetFocusHWND(){ return NULL; }

	HWND    GetHWND() { return hWndMain; };

	virtual void Resize( int, int, int, int );
	virtual void ReResize();

	virtual void WF_Tick(){}

	virtual LRESULT CALLBACK Parse_WM_MOUSEWHEEL( HWND, UINT, WPARAM, LPARAM ){ return 0; }
	virtual LRESULT CALLBACK Parse_Keyboard_WMs( HWND, UINT msg, WPARAM wParam, LPARAM )
	{
		if( msg == WM_CHAR && KeyboardReceiver ) { KeyboardReceiver( wParam ); }
		return 0;
	}
	//
	virtual WorkfieldOwnerInterface* Get_pWOI(){ return NULL; }
	virtual void Set_pWOI( WorkfieldOwnerInterface *p_WOI ){}


protected:
	virtual ~WorkField();

	void DefaultConstructor( const char* const, unsigned int* );
	//      
    WorkField(){}

	static LRESULT CALLBACK WndProc1( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
	static LRESULT CALLBACK WndProc2( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

	LRESULT CALLBACK OuterWndProc( HWND, UINT, WPARAM, LPARAM );
	LRESULT CALLBACK MasterWndProc( HWND, UINT, WPARAM, LPARAM );

	virtual LRESULT CALLBACK ParseFrame_WM_SIZE( HWND, UINT, WPARAM, LPARAM ) { return 0; }
	virtual LRESULT CALLBACK Parse_WM_SIZE( HWND, UINT, WPARAM, LPARAM )      { return 0; }
	virtual LRESULT CALLBACK Parse_WM_COMMAND( HWND, UINT, WPARAM, LPARAM )   { return 0; }
	virtual LRESULT CALLBACK Parse_WM_SETFOCUS( HWND, UINT, WPARAM, LPARAM )  { return 0; }
	virtual LRESULT CALLBACK Parse_WM_ERASEBKGND( HWND, UINT, WPARAM, LPARAM ){ return 0; }

	char  acObjectName[128];
	int   ObjectsCount( int*, bool = false );

	bool bObjectDestroing;
	bool bWindowDestroed;

	int  nEmbeddedBorderWidth;

	bool bIsEmbedded;
	bool bIsChild;
	HWND hWndParent;

	//  HDC  hDCmain;
	//  HDC  hDCfield;

	HGDIOBJ hWorkWindowBackgrownd;

	HWND    hWndOuterFrame;
	HWND    hWndMain;

	int nX0;
	int nY0;
	int nDX;
	int nDY;

	fastdelegate::FastDelegate1<char> KeyboardReceiver;

private:

	static unsigned int nObjectsCount;

};

#endif


#ifndef WFConsoleClassDefs
#define WFConsoleClassDefs 1

#include "console_class.h"
//
//  WFConsole -  
//

class WFConsole : public WorkField {

public:

	WFConsole( DWindowInitData* );

	void StrOut( const char* );

	static const char* const CLASS_NAME; // = "WFConsole";

	virtual void Resize( int, int, int, int );
	virtual void WF_Tick();

	virtual LRESULT CALLBACK Parse_WM_MOUSEWHEEL( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
	{ 
		if( Con ) { return Con->Parse_WM_MOUSEWHEEL( hWnd, msg, wParam, lParam ); }
		return 0;
	}
//
	void  SetLogFile( const char *acPath ) { if( Con ) Con->SetLogFile( acPath ); }
	void  StartLog()                       { if( Con ) Con->StartLog();           }
	void  StopLog()                        { if( Con ) Con->StopLog();            }
	void  CloseLog()                       { if( Con ) Con->CloseLog();           }
	void  FlushLogData()                   { if( Con ) Con->FlushLogData();       }
	

protected:
	virtual ~WFConsole(){};

	Console *Con;
	DWindowInitData ConInitData;

	virtual LRESULT CALLBACK Parse_WM_SIZE( HWND, UINT, WPARAM, LPARAM );

private:

	static unsigned int nObjectsCount;

};

#endif


//
//  WFObject -  
//

#ifndef WFObjectClassDefs
#define WFObjectClassDefs 1

#include "FastDelegate.h"
 
#define   WFObject_CLASS_NAME  "WFObject"

 
class WFObject : public WorkField {
public:
	static const char* const CLASS_NAME; // = "WFObject";

	WFObject( DWindowInitData*, WorkfieldOwnerInterface* );

protected:
	virtual void Resize( int, int, int, int );
	virtual void WF_Tick();

	virtual HWND GetFocusHWND()
	{ 
		if( bIsChild && pWOI ) { return pWOI->GetFocusHWND(); }
		return NULL;
	}

	virtual LRESULT CALLBACK Parse_WM_ERASEBKGND( HWND, UINT, WPARAM, LPARAM );
	virtual LRESULT CALLBACK ParseFrame_WM_SIZE( HWND, UINT, WPARAM wParam, LPARAM lParam );

	virtual LRESULT CALLBACK Parse_WM_MOUSEWHEEL( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
	{ 
		if( pWOI ) { return pWOI->Parse_WM_MOUSEWHEEL( hWnd, msg, wParam, lParam ); }
		return 0;
	}
	virtual LRESULT CALLBACK Parse_Keyboard_WMs( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
	{
		if( pWOI ) { return pWOI->Parse_Keyboard_WMs( hWnd, msg, wParam, lParam ); }
		return 0;
	}
  
//*
	virtual LRESULT CALLBACK Parse_WM_SETFOCUS( HWND, UINT, WPARAM, LPARAM )
	{
		HWND hWndFocus = pWOI->GetFocusHWND();
/*
{
char str[512];
sprintf(str,"WF[0x%X] Parse_WM_SETFOCUS: hWndFocus[0x%X] ; hWndParent[0x%X]\n", this, hWndFocus, hWndParent );
//pWOI->Get_pOwner()->ConStrOut(str);
ConStrOut(str);
}//*/
		if( hWndFocus )
		{
			SetFocus( hWndFocus );
		}
		else        
		{
			if( bIsEmbedded && hWndParent )
			{
				SetFocus( hWndParent );
			}
		}
		return 1; 
	}//*/
//
	virtual void Activate( bool bActive ){ if( pWOI ) pWOI->WF_ActiveStateChanged( bActive );  }

	virtual WorkfieldOwnerInterface* Get_pWOI(){ return pWOI; }

	virtual ~WFObject(){}

	virtual void Set_pWOI( WorkfieldOwnerInterface *p_WOI ){ pWOI = p_WOI; }

	WorkfieldOwnerInterface *pWOI;

	virtual LRESULT CALLBACK Parse_WM_SIZE( HWND, UINT, WPARAM, LPARAM );

    
private:
	static unsigned int nObjectsCount;
};

#endif
